VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3780
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8370
   LinkTopic       =   "Form1"
   ScaleHeight     =   3780
   ScaleWidth      =   8370
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Find"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   735
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   4335
      _ExtentX        =   7646
      _ExtentY        =   4471
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_SortColumn As Integer
Private m_SortAscending As Integer

Private Sub AddRow(ByVal last_name As String, ByVal first_name As String, ByVal street As String, ByVal city As String, ByVal state As String)
Static row_num As Integer

    row_num = row_num + 1
    MSFlexGrid1.TextMatrix(row_num, 0) = last_name
    MSFlexGrid1.TextMatrix(row_num, 1) = first_name
    MSFlexGrid1.TextMatrix(row_num, 2) = street
    MSFlexGrid1.TextMatrix(row_num, 3) = city
    MSFlexGrid1.TextMatrix(row_num, 4) = state

    MSFlexGrid1.TextMatrix(row_num, 5) = _
        Format$(Int((99999 - 0 + 1) * Rnd + 0), "00000")

    MSFlexGrid1.TextMatrix(row_num, 6) = _
        Format$(Int((999 - 2 + 1) * Rnd + 2), "000") & "-" & _
        Format$(Int((999 - 2 + 1) * Rnd + 2), "000") & "-" & _
        Format$(Int((9999 - 0 + 1) * Rnd + 0), "0000")
End Sub
Private Sub Command1_Click()
Dim target_name As String
Dim r As Integer

    ' Get the name.
    target_name = InputBox("Name", "Name", "")
    If Len(target_name) = 0 Then Exit Sub

    ' Search for the name, skipping the column heading row.
    target_name = LCase$(target_name)
    For r = 1 To MSFlexGrid1.Rows - 1
        If LCase$(MSFlexGrid1.TextMatrix(r, 0)) = target_name Then
            ' We found the target. Select this row.
            MSFlexGrid1.Row = r
            MSFlexGrid1.RowSel = r
            MSFlexGrid1.Col = 0
            MSFlexGrid1.ColSel = MSFlexGrid1.Cols - 1

            ' Make the row visible.
            MSFlexGrid1.TopRow = r
            Exit Sub
        End If
    Next r

    ' We didn't find it.
    Beep
End Sub
' Make some test data.
Private Sub Form_Load()
Dim r As Integer
Dim c As Integer
Dim wid As Single
Dim col_width() As Single

    MSFlexGrid1.Rows = 20
    MSFlexGrid1.Cols = 7

    ' Column headings.
    MSFlexGrid1.TextMatrix(0, 0) = "Last Name"
    MSFlexGrid1.TextMatrix(0, 1) = "First Name"
    MSFlexGrid1.TextMatrix(0, 2) = "Street"
    MSFlexGrid1.TextMatrix(0, 3) = "City"
    MSFlexGrid1.TextMatrix(0, 4) = "State"
    MSFlexGrid1.TextMatrix(0, 5) = "Zip"
    MSFlexGrid1.TextMatrix(0, 6) = "Phone"
    MSFlexGrid1.FixedRows = 1
    MSFlexGrid1.FixedCols = 0

    For c = 0 To MSFlexGrid1.Cols - 1
        MSFlexGrid1.ColAlignment(c) = flexAlignLeftTop
    Next c

    ' Add data.
    AddRow "Pierce", "Mike", "3654 1st Ave", "Warring", "AZ"
    AddRow "Everson", "Stephen", "8943 Pine St", "Alma", "VT"
    AddRow "Smythe", "Miles", "8 Walnut Ct #4", "Visual", "UT"
    AddRow "O'Donnell", "Janice", "998 Wait Pl", "Oeidie", "CO"
    AddRow "Abbas", "Cindy", "1001010 Binary Way", "Bibbsonville", "GA"
    AddRow "Johnson", "Andrew", "1 Savant", "Watt", "KS"
    AddRow "Badgers", "Anita", "76 Speaker", "Elver", "CA"
    AddRow "Garcia", "Lloyd", "8902 Forest", "Bluetree", "MA"
    AddRow "Caustine", "Barnett", "94873-A Xtor", "Calabassiss", "WY"
    AddRow "Dvorak", "Skip", "764 Rotary Dr", "Tapper", "NV"
    AddRow "Watt", "Amy", "1092 Algol", "Direct", "MO"
    AddRow "Stephens", "Merlin", "736 Cats Way", "Mindset", "MT"
    AddRow "Gleick", "Samantha", "87 Datacom Terr", "Edger", "OK"
    AddRow "Cooper", "Betty", "84873 Street St", "Flete", "AL"
    AddRow "Pascal", "Warren", "4368 Opselwacspec", "Navy", "MD"
    AddRow "Warhol", "Marie", "4637 Plansway", "Dracoin", "AK"
    AddRow "Davis", "Wendy", "398 Tiling Pl", "System", "ID"
    AddRow "Aho", "Mortise", "323454 Plate Way", "Bollingsworthy", "TN"
    AddRow "McConnell", "Jose", "923 X Pl", "Ontoppa", "WA"

    ' Size the columns.
    ReDim col_width(0 To MSFlexGrid1.Cols - 1)
    For r = 0 To MSFlexGrid1.Rows - 1
        For c = 0 To MSFlexGrid1.Cols - 1
            wid = TextWidth(MSFlexGrid1.TextMatrix(r, c)) + 240
            If col_width(c) < wid Then col_width(c) = wid
        Next c
    Next r

    For c = 0 To MSFlexGrid1.Cols - 1
        MSFlexGrid1.ColWidth(c) = col_width(c)
    Next c

    ' Start with no column sorted.
    m_SortColumn = -1
End Sub
Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - MSFlexGrid1.Top
    If hgt < 120 Then hgt = 120
    MSFlexGrid1.Move 0, MSFlexGrid1.Top, ScaleWidth, hgt
End Sub


Private Sub MSFlexGrid1_Click()
Dim txt As String

    ' See if the user clicked row 0.
    If MSFlexGrid1.MouseRow > 0 Then Exit Sub

    ' See if this is the same column.
    If MSFlexGrid1.MouseCol = m_SortColumn Then
        ' This is the current sort column.
        ' Change the sort order and the column title.
        m_SortAscending = Not m_SortAscending
        If m_SortAscending Then
            MSFlexGrid1.TextMatrix(0, m_SortColumn) = _
                "> " & Mid$(MSFlexGrid1.TextMatrix(0, m_SortColumn), 3)
        Else
            MSFlexGrid1.TextMatrix(0, m_SortColumn) = _
                "< " & Mid$(MSFlexGrid1.TextMatrix(0, m_SortColumn), 3)
        End If
    Else
        ' This is a new sort column.
        ' Restore the previous sorting column's name.
        If m_SortColumn >= 0 Then
            MSFlexGrid1.TextMatrix(0, m_SortColumn) = _
                Mid$(MSFlexGrid1.TextMatrix(0, m_SortColumn), 3)
        End If

        ' Save the new sort column.
        m_SortColumn = MSFlexGrid1.MouseCol

        ' Sort using the new column.
        m_SortAscending = True
        MSFlexGrid1.TextMatrix(0, m_SortColumn) = _
            "> " & MSFlexGrid1.TextMatrix(0, m_SortColumn)
    End If

    MSFlexGrid1.Row = 1
    MSFlexGrid1.RowSel = MSFlexGrid1.Rows - 1
    MSFlexGrid1.Col = m_SortColumn

    If m_SortAscending Then
        Select Case m_SortColumn
            Case 2, 5, 6
                MSFlexGrid1.Sort = flexSortNumericAscending
            Case Else
                MSFlexGrid1.Sort = flexSortStringAscending
        End Select
    Else
        Select Case m_SortColumn
            Case 2, 5, 6
                MSFlexGrid1.Sort = flexSortNumericDescending
            Case Else
                MSFlexGrid1.Sort = flexSortStringDescending
        End Select
    End If
End Sub
